#include <iostream>
#include <memory>
#include <string>

class Resource {
public:
    Resource(const std::string& s) : data_(s) {
        std::cout << "Resource acquired: " << data_ << std::endl;
    }
    ~Resource() {
        std::cout << "Resource released: " << data_ << std::endl;
    }
    void use() const {
        std::cout << "Using resource: " << data_ << std::endl;
    }
private:
    std::string data_;
};

std::unique_ptr<Resource> createResource(const std::string& data) {
    return std::make_unique<Resource>(data);
}

int main() {
    auto resource = createResource("Important Data");
    resource->use();
    return 0;
}
